// Code generated by protoc-gen-go. DO NOT EDIT.
// source: types.proto

package concept

import (
	fmt "fmt"
	proto "github.com/golang/protobuf/proto"
	math "math"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion3 // please upgrade the proto package

// ContentType enumerates all built-in content types those Element's
// raw could be.
type ContentType int32

const (
	ContentType_UNKNOWN ContentType = 0
	// application/json
	ContentType_JSON ContentType = 1
	// application/toml
	ContentType_TOML ContentType = 2
	// application/ini
	ContentType_INI ContentType = 3
	// application/plaintext
	ContentType_PLAINTEXT ContentType = 4
)

var ContentType_name = map[int32]string{
	0: "UNKNOWN",
	1: "JSON",
	2: "TOML",
	3: "INI",
	4: "PLAINTEXT",
}

var ContentType_value = map[string]int32{
	"UNKNOWN":   0,
	"JSON":      1,
	"TOML":      2,
	"INI":       3,
	"PLAINTEXT": 4,
}

func (x ContentType) String() string {
	return proto.EnumName(ContentType_name, int32(x))
}

func (ContentType) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_d938547f84707355, []int{0}
}

type Operation int32

const (
	Operation_INVALID Operation = 0
	Operation_SET     Operation = 1
	Operation_UNSET   Operation = 2
	Operation_PUBLISH Operation = 3
)

var Operation_name = map[int32]string{
	0: "INVALID",
	1: "SET",
	2: "UNSET",
	3: "PUBLISH",
}

var Operation_value = map[string]int32{
	"INVALID": 0,
	"SET":     1,
	"UNSET":   2,
	"PUBLISH": 3,
}

func (x Operation) String() string {
	return proto.EnumName(Operation_name, int32(x))
}

func (Operation) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_d938547f84707355, []int{1}
}

type ChangeOp int32

const (
	ChangeOp_UNDEFINED ChangeOp = 0
	ChangeOp_NEW       ChangeOp = 1
	ChangeOp_UPDATE    ChangeOp = 2
	ChangeOp_DELETE    ChangeOp = 3
)

var ChangeOp_name = map[int32]string{
	0: "UNDEFINED",
	1: "NEW",
	2: "UPDATE",
	3: "DELETE",
}

var ChangeOp_value = map[string]int32{
	"UNDEFINED": 0,
	"NEW":       1,
	"UPDATE":    2,
	"DELETE":    3,
}

func (x ChangeOp) String() string {
	return proto.EnumName(ChangeOp_name, int32(x))
}

func (ChangeOp) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_d938547f84707355, []int{2}
}

// Element represent a config element with specific version.
type Element struct {
	// refer ElementMetadata
	Metadata *ElementMetadata `protobuf:"bytes,1,opt,name=metadata,proto3" json:"metadata,omitempty"`
	// raw data in the version.
	Raw []byte `protobuf:"bytes,2,opt,name=raw,proto3" json:"raw,omitempty"`
	// version number start since 1.
	Version int32 `protobuf:"varint,3,opt,name=version,proto3" json:"version,omitempty"`
	// indicates published or not.
	Published            bool     `protobuf:"varint,4,opt,name=published,proto3" json:"published,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *Element) Reset()         { *m = Element{} }
func (m *Element) String() string { return proto.CompactTextString(m) }
func (*Element) ProtoMessage()    {}
func (*Element) Descriptor() ([]byte, []int) {
	return fileDescriptor_d938547f84707355, []int{0}
}

func (m *Element) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Element.Unmarshal(m, b)
}
func (m *Element) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Element.Marshal(b, m, deterministic)
}
func (m *Element) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Element.Merge(m, src)
}
func (m *Element) XXX_Size() int {
	return xxx_messageInfo_Element.Size(m)
}
func (m *Element) XXX_DiscardUnknown() {
	xxx_messageInfo_Element.DiscardUnknown(m)
}

var xxx_messageInfo_Element proto.InternalMessageInfo

func (m *Element) GetMetadata() *ElementMetadata {
	if m != nil {
		return m.Metadata
	}
	return nil
}

func (m *Element) GetRaw() []byte {
	if m != nil {
		return m.Raw
	}
	return nil
}

func (m *Element) GetVersion() int32 {
	if m != nil {
		return m.Version
	}
	return 0
}

func (m *Element) GetPublished() bool {
	if m != nil {
		return m.Published
	}
	return false
}

// ElementMetadata contains metadata of one element, includes
// specific key, app, env attributes, and other fields to display
// the element's version status.
type ElementMetadata struct {
	Key string `protobuf:"bytes,1,opt,name=key,proto3" json:"key,omitempty"`
	App string `protobuf:"bytes,2,opt,name=app,proto3" json:"app,omitempty"`
	Env string `protobuf:"bytes,3,opt,name=env,proto3" json:"env,omitempty"`
	// the latest version in all versions of the element.
	LatestVersion int32 `protobuf:"varint,4,opt,name=latestVersion,proto3" json:"latestVersion,omitempty"`
	// if there is any unpublished version, if there's any unpublished
	// version, the element can not create a new version util all versions have been
	// published,
	UnpublishedVersion int32 `protobuf:"varint,5,opt,name=unpublishedVersion,proto3" json:"unpublishedVersion,omitempty"`
	// the in-use version.
	UsingVersion int32 `protobuf:"varint,6,opt,name=usingVersion,proto3" json:"usingVersion,omitempty"`
	// the using version's fingerprint.
	UsingFingerprint string `protobuf:"bytes,7,opt,name=usingFingerprint,proto3" json:"usingFingerprint,omitempty"`
	// indicates the content type of Element's raw data
	ContentType          ContentType `protobuf:"varint,8,opt,name=contentType,proto3,enum=cassem.concept.ContentType" json:"contentType,omitempty"`
	XXX_NoUnkeyedLiteral struct{}    `json:"-"`
	XXX_unrecognized     []byte      `json:"-"`
	XXX_sizecache        int32       `json:"-"`
}

func (m *ElementMetadata) Reset()         { *m = ElementMetadata{} }
func (m *ElementMetadata) String() string { return proto.CompactTextString(m) }
func (*ElementMetadata) ProtoMessage()    {}
func (*ElementMetadata) Descriptor() ([]byte, []int) {
	return fileDescriptor_d938547f84707355, []int{1}
}

func (m *ElementMetadata) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_ElementMetadata.Unmarshal(m, b)
}
func (m *ElementMetadata) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_ElementMetadata.Marshal(b, m, deterministic)
}
func (m *ElementMetadata) XXX_Merge(src proto.Message) {
	xxx_messageInfo_ElementMetadata.Merge(m, src)
}
func (m *ElementMetadata) XXX_Size() int {
	return xxx_messageInfo_ElementMetadata.Size(m)
}
func (m *ElementMetadata) XXX_DiscardUnknown() {
	xxx_messageInfo_ElementMetadata.DiscardUnknown(m)
}

var xxx_messageInfo_ElementMetadata proto.InternalMessageInfo

func (m *ElementMetadata) GetKey() string {
	if m != nil {
		return m.Key
	}
	return ""
}

func (m *ElementMetadata) GetApp() string {
	if m != nil {
		return m.App
	}
	return ""
}

func (m *ElementMetadata) GetEnv() string {
	if m != nil {
		return m.Env
	}
	return ""
}

func (m *ElementMetadata) GetLatestVersion() int32 {
	if m != nil {
		return m.LatestVersion
	}
	return 0
}

func (m *ElementMetadata) GetUnpublishedVersion() int32 {
	if m != nil {
		return m.UnpublishedVersion
	}
	return 0
}

func (m *ElementMetadata) GetUsingVersion() int32 {
	if m != nil {
		return m.UsingVersion
	}
	return 0
}

func (m *ElementMetadata) GetUsingFingerprint() string {
	if m != nil {
		return m.UsingFingerprint
	}
	return ""
}

func (m *ElementMetadata) GetContentType() ContentType {
	if m != nil {
		return m.ContentType
	}
	return ContentType_UNKNOWN
}

type AppMetadata struct {
	Id                   string   `protobuf:"bytes,1,opt,name=id,proto3" json:"id,omitempty"`
	Description          string   `protobuf:"bytes,2,opt,name=description,proto3" json:"description,omitempty"`
	CreatedAt            int64    `protobuf:"varint,3,opt,name=createdAt,proto3" json:"createdAt,omitempty"`
	Creator              string   `protobuf:"bytes,4,opt,name=creator,proto3" json:"creator,omitempty"`
	Owner                string   `protobuf:"bytes,5,opt,name=owner,proto3" json:"owner,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *AppMetadata) Reset()         { *m = AppMetadata{} }
func (m *AppMetadata) String() string { return proto.CompactTextString(m) }
func (*AppMetadata) ProtoMessage()    {}
func (*AppMetadata) Descriptor() ([]byte, []int) {
	return fileDescriptor_d938547f84707355, []int{2}
}

func (m *AppMetadata) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_AppMetadata.Unmarshal(m, b)
}
func (m *AppMetadata) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_AppMetadata.Marshal(b, m, deterministic)
}
func (m *AppMetadata) XXX_Merge(src proto.Message) {
	xxx_messageInfo_AppMetadata.Merge(m, src)
}
func (m *AppMetadata) XXX_Size() int {
	return xxx_messageInfo_AppMetadata.Size(m)
}
func (m *AppMetadata) XXX_DiscardUnknown() {
	xxx_messageInfo_AppMetadata.DiscardUnknown(m)
}

var xxx_messageInfo_AppMetadata proto.InternalMessageInfo

func (m *AppMetadata) GetId() string {
	if m != nil {
		return m.Id
	}
	return ""
}

func (m *AppMetadata) GetDescription() string {
	if m != nil {
		return m.Description
	}
	return ""
}

func (m *AppMetadata) GetCreatedAt() int64 {
	if m != nil {
		return m.CreatedAt
	}
	return 0
}

func (m *AppMetadata) GetCreator() string {
	if m != nil {
		return m.Creator
	}
	return ""
}

func (m *AppMetadata) GetOwner() string {
	if m != nil {
		return m.Owner
	}
	return ""
}

type ElementOperation struct {
	Operator             string    `protobuf:"bytes,1,opt,name=operator,proto3" json:"operator,omitempty"`
	OperatedAt           int64     `protobuf:"varint,2,opt,name=operatedAt,proto3" json:"operatedAt,omitempty"`
	OperatedKey          string    `protobuf:"bytes,3,opt,name=operatedKey,proto3" json:"operatedKey,omitempty"`
	Op                   Operation `protobuf:"varint,4,opt,name=op,proto3,enum=cassem.concept.Operation" json:"op,omitempty"`
	LastVersion          int32     `protobuf:"varint,5,opt,name=lastVersion,proto3" json:"lastVersion,omitempty"`
	CurrentVersion       int32     `protobuf:"varint,6,opt,name=currentVersion,proto3" json:"currentVersion,omitempty"`
	Remark               string    `protobuf:"bytes,7,opt,name=remark,proto3" json:"remark,omitempty"`
	XXX_NoUnkeyedLiteral struct{}  `json:"-"`
	XXX_unrecognized     []byte    `json:"-"`
	XXX_sizecache        int32     `json:"-"`
}

func (m *ElementOperation) Reset()         { *m = ElementOperation{} }
func (m *ElementOperation) String() string { return proto.CompactTextString(m) }
func (*ElementOperation) ProtoMessage()    {}
func (*ElementOperation) Descriptor() ([]byte, []int) {
	return fileDescriptor_d938547f84707355, []int{3}
}

func (m *ElementOperation) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_ElementOperation.Unmarshal(m, b)
}
func (m *ElementOperation) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_ElementOperation.Marshal(b, m, deterministic)
}
func (m *ElementOperation) XXX_Merge(src proto.Message) {
	xxx_messageInfo_ElementOperation.Merge(m, src)
}
func (m *ElementOperation) XXX_Size() int {
	return xxx_messageInfo_ElementOperation.Size(m)
}
func (m *ElementOperation) XXX_DiscardUnknown() {
	xxx_messageInfo_ElementOperation.DiscardUnknown(m)
}

var xxx_messageInfo_ElementOperation proto.InternalMessageInfo

func (m *ElementOperation) GetOperator() string {
	if m != nil {
		return m.Operator
	}
	return ""
}

func (m *ElementOperation) GetOperatedAt() int64 {
	if m != nil {
		return m.OperatedAt
	}
	return 0
}

func (m *ElementOperation) GetOperatedKey() string {
	if m != nil {
		return m.OperatedKey
	}
	return ""
}

func (m *ElementOperation) GetOp() Operation {
	if m != nil {
		return m.Op
	}
	return Operation_INVALID
}

func (m *ElementOperation) GetLastVersion() int32 {
	if m != nil {
		return m.LastVersion
	}
	return 0
}

func (m *ElementOperation) GetCurrentVersion() int32 {
	if m != nil {
		return m.CurrentVersion
	}
	return 0
}

func (m *ElementOperation) GetRemark() string {
	if m != nil {
		return m.Remark
	}
	return ""
}

// Instance describes client instance.
type Instance struct {
	ClientId             string   `protobuf:"bytes,1,opt,name=clientId,proto3" json:"clientId,omitempty"`
	AgentId              string   `protobuf:"bytes,2,opt,name=agentId,proto3" json:"agentId,omitempty"`
	ClientIp             string   `protobuf:"bytes,3,opt,name=clientIp,proto3" json:"clientIp,omitempty"`
	App                  string   `protobuf:"bytes,4,opt,name=app,proto3" json:"app,omitempty"`
	Env                  string   `protobuf:"bytes,5,opt,name=env,proto3" json:"env,omitempty"`
	WatchKeys            []string `protobuf:"bytes,6,rep,name=watchKeys,proto3" json:"watchKeys,omitempty"`
	LastRenewTimestamp   int64    `protobuf:"varint,7,opt,name=lastRenewTimestamp,proto3" json:"lastRenewTimestamp,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *Instance) Reset()         { *m = Instance{} }
func (m *Instance) String() string { return proto.CompactTextString(m) }
func (*Instance) ProtoMessage()    {}
func (*Instance) Descriptor() ([]byte, []int) {
	return fileDescriptor_d938547f84707355, []int{4}
}

func (m *Instance) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Instance.Unmarshal(m, b)
}
func (m *Instance) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Instance.Marshal(b, m, deterministic)
}
func (m *Instance) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Instance.Merge(m, src)
}
func (m *Instance) XXX_Size() int {
	return xxx_messageInfo_Instance.Size(m)
}
func (m *Instance) XXX_DiscardUnknown() {
	xxx_messageInfo_Instance.DiscardUnknown(m)
}

var xxx_messageInfo_Instance proto.InternalMessageInfo

func (m *Instance) GetClientId() string {
	if m != nil {
		return m.ClientId
	}
	return ""
}

func (m *Instance) GetAgentId() string {
	if m != nil {
		return m.AgentId
	}
	return ""
}

func (m *Instance) GetClientIp() string {
	if m != nil {
		return m.ClientIp
	}
	return ""
}

func (m *Instance) GetApp() string {
	if m != nil {
		return m.App
	}
	return ""
}

func (m *Instance) GetEnv() string {
	if m != nil {
		return m.Env
	}
	return ""
}

func (m *Instance) GetWatchKeys() []string {
	if m != nil {
		return m.WatchKeys
	}
	return nil
}

func (m *Instance) GetLastRenewTimestamp() int64 {
	if m != nil {
		return m.LastRenewTimestamp
	}
	return 0
}

// AgentInstance describes agent node instance attributes.
type AgentInstance struct {
	// agentId is the unique identifier for agent.
	AgentId string `protobuf:"bytes,1,opt,name=agentId,proto3" json:"agentId,omitempty"`
	Addr    string `protobuf:"bytes,2,opt,name=addr,proto3" json:"addr,omitempty"`
	// annotations contains the some custom label and value of AgentInstance.
	Annotations          map[string]string `protobuf:"bytes,3,rep,name=annotations,proto3" json:"annotations,omitempty" protobuf_key:"bytes,1,opt,name=key,proto3" protobuf_val:"bytes,2,opt,name=value,proto3"`
	XXX_NoUnkeyedLiteral struct{}          `json:"-"`
	XXX_unrecognized     []byte            `json:"-"`
	XXX_sizecache        int32             `json:"-"`
}

func (m *AgentInstance) Reset()         { *m = AgentInstance{} }
func (m *AgentInstance) String() string { return proto.CompactTextString(m) }
func (*AgentInstance) ProtoMessage()    {}
func (*AgentInstance) Descriptor() ([]byte, []int) {
	return fileDescriptor_d938547f84707355, []int{5}
}

func (m *AgentInstance) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_AgentInstance.Unmarshal(m, b)
}
func (m *AgentInstance) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_AgentInstance.Marshal(b, m, deterministic)
}
func (m *AgentInstance) XXX_Merge(src proto.Message) {
	xxx_messageInfo_AgentInstance.Merge(m, src)
}
func (m *AgentInstance) XXX_Size() int {
	return xxx_messageInfo_AgentInstance.Size(m)
}
func (m *AgentInstance) XXX_DiscardUnknown() {
	xxx_messageInfo_AgentInstance.DiscardUnknown(m)
}

var xxx_messageInfo_AgentInstance proto.InternalMessageInfo

func (m *AgentInstance) GetAgentId() string {
	if m != nil {
		return m.AgentId
	}
	return ""
}

func (m *AgentInstance) GetAddr() string {
	if m != nil {
		return m.Addr
	}
	return ""
}

func (m *AgentInstance) GetAnnotations() map[string]string {
	if m != nil {
		return m.Annotations
	}
	return nil
}

type AgentInstanceChange struct {
	Ins                  *AgentInstance `protobuf:"bytes,1,opt,name=ins,proto3" json:"ins,omitempty"`
	Op                   ChangeOp       `protobuf:"varint,2,opt,name=op,proto3,enum=cassem.concept.ChangeOp" json:"op,omitempty"`
	XXX_NoUnkeyedLiteral struct{}       `json:"-"`
	XXX_unrecognized     []byte         `json:"-"`
	XXX_sizecache        int32          `json:"-"`
}

func (m *AgentInstanceChange) Reset()         { *m = AgentInstanceChange{} }
func (m *AgentInstanceChange) String() string { return proto.CompactTextString(m) }
func (*AgentInstanceChange) ProtoMessage()    {}
func (*AgentInstanceChange) Descriptor() ([]byte, []int) {
	return fileDescriptor_d938547f84707355, []int{6}
}

func (m *AgentInstanceChange) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_AgentInstanceChange.Unmarshal(m, b)
}
func (m *AgentInstanceChange) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_AgentInstanceChange.Marshal(b, m, deterministic)
}
func (m *AgentInstanceChange) XXX_Merge(src proto.Message) {
	xxx_messageInfo_AgentInstanceChange.Merge(m, src)
}
func (m *AgentInstanceChange) XXX_Size() int {
	return xxx_messageInfo_AgentInstanceChange.Size(m)
}
func (m *AgentInstanceChange) XXX_DiscardUnknown() {
	xxx_messageInfo_AgentInstanceChange.DiscardUnknown(m)
}

var xxx_messageInfo_AgentInstanceChange proto.InternalMessageInfo

func (m *AgentInstanceChange) GetIns() *AgentInstance {
	if m != nil {
		return m.Ins
	}
	return nil
}

func (m *AgentInstanceChange) GetOp() ChangeOp {
	if m != nil {
		return m.Op
	}
	return ChangeOp_UNDEFINED
}

func init() {
	proto.RegisterEnum("cassem.concept.ContentType", ContentType_name, ContentType_value)
	proto.RegisterEnum("cassem.concept.Operation", Operation_name, Operation_value)
	proto.RegisterEnum("cassem.concept.ChangeOp", ChangeOp_name, ChangeOp_value)
	proto.RegisterType((*Element)(nil), "cassem.concept.Element")
	proto.RegisterType((*ElementMetadata)(nil), "cassem.concept.ElementMetadata")
	proto.RegisterType((*AppMetadata)(nil), "cassem.concept.AppMetadata")
	proto.RegisterType((*ElementOperation)(nil), "cassem.concept.ElementOperation")
	proto.RegisterType((*Instance)(nil), "cassem.concept.Instance")
	proto.RegisterType((*AgentInstance)(nil), "cassem.concept.AgentInstance")
	proto.RegisterMapType((map[string]string)(nil), "cassem.concept.AgentInstance.AnnotationsEntry")
	proto.RegisterType((*AgentInstanceChange)(nil), "cassem.concept.AgentInstanceChange")
}

func init() { proto.RegisterFile("types.proto", fileDescriptor_d938547f84707355) }

var fileDescriptor_d938547f84707355 = []byte{
	// 796 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x7c, 0x55, 0xdd, 0x6e, 0xe3, 0x44,
	0x14, 0xde, 0xb1, 0xf3, 0xe7, 0xe3, 0x6d, 0xb0, 0x86, 0x15, 0x32, 0xcb, 0x02, 0x91, 0x85, 0x90,
	0xe9, 0x45, 0x90, 0xca, 0x0d, 0x2c, 0x02, 0x29, 0xbb, 0x75, 0x85, 0x69, 0xd6, 0xa9, 0xa6, 0xce,
	0x2e, 0xe2, 0x6e, 0xd6, 0x1e, 0xb5, 0xd6, 0x26, 0xe3, 0xd1, 0x78, 0xd2, 0x2a, 0x0f, 0x81, 0xc4,
	0x83, 0xf0, 0x2c, 0xf0, 0x44, 0x48, 0x68, 0x26, 0x76, 0xec, 0xa4, 0x15, 0x77, 0xe7, 0xfb, 0xfc,
	0xcd, 0x9c, 0xef, 0xfc, 0x4c, 0x02, 0xae, 0xda, 0x0a, 0x56, 0x4d, 0x85, 0x2c, 0x55, 0x89, 0xc7,
	0x19, 0xad, 0x2a, 0xb6, 0x9e, 0x66, 0x25, 0xcf, 0x98, 0x50, 0xc1, 0x9f, 0x08, 0x86, 0xd1, 0x8a,
	0xad, 0x19, 0x57, 0xf8, 0x47, 0x18, 0xad, 0x99, 0xa2, 0x39, 0x55, 0xd4, 0x47, 0x13, 0x14, 0xba,
	0x67, 0x5f, 0x4e, 0x0f, 0xe5, 0xd3, 0x5a, 0xfa, 0xa6, 0x96, 0x91, 0xfd, 0x01, 0xec, 0x81, 0x2d,
	0xe9, 0xbd, 0x6f, 0x4d, 0x50, 0xf8, 0x94, 0xe8, 0x10, 0xfb, 0x30, 0xbc, 0x63, 0xb2, 0x2a, 0x4a,
	0xee, 0xdb, 0x13, 0x14, 0xf6, 0x49, 0x03, 0xf1, 0x0b, 0x70, 0xc4, 0xe6, 0xfd, 0xaa, 0xa8, 0x6e,
	0x59, 0xee, 0xf7, 0x26, 0x28, 0x1c, 0x91, 0x96, 0x08, 0xfe, 0xb2, 0xe0, 0xa3, 0xa3, 0x3c, 0xfa,
	0xf6, 0x0f, 0x6c, 0x6b, 0x5c, 0x39, 0x44, 0x87, 0x9a, 0xa1, 0x42, 0x98, 0x7c, 0x0e, 0xd1, 0xa1,
	0x66, 0x18, 0xbf, 0x33, 0xb9, 0x1c, 0xa2, 0x43, 0xfc, 0x15, 0x9c, 0xac, 0xa8, 0x62, 0x95, 0x7a,
	0x5b, 0xfb, 0xe8, 0x19, 0x1f, 0x87, 0x24, 0x9e, 0x02, 0xde, 0xf0, 0x7d, 0xfa, 0x46, 0xda, 0x37,
	0xd2, 0x47, 0xbe, 0xe0, 0x00, 0x9e, 0x6e, 0xaa, 0x82, 0xdf, 0x34, 0xca, 0x81, 0x51, 0x1e, 0x70,
	0xf8, 0x14, 0x3c, 0x83, 0x2f, 0x0a, 0x7e, 0xc3, 0xa4, 0x90, 0x05, 0x57, 0xfe, 0xd0, 0x18, 0x7b,
	0xc0, 0xe3, 0x9f, 0xc0, 0xcd, 0x4a, 0xae, 0x18, 0x57, 0xe9, 0x56, 0x30, 0x7f, 0x34, 0x41, 0xe1,
	0xf8, 0xec, 0xb3, 0xe3, 0xce, 0xbf, 0x6e, 0x25, 0xa4, 0xab, 0x0f, 0xfe, 0x40, 0xe0, 0xce, 0x84,
	0xd8, 0xb7, 0x6a, 0x0c, 0x56, 0x91, 0xd7, 0x9d, 0xb2, 0x8a, 0x1c, 0x4f, 0xc0, 0xcd, 0x59, 0x95,
	0xc9, 0x42, 0x28, 0xed, 0x76, 0xd7, 0xb0, 0x2e, 0xa5, 0xc7, 0x91, 0x49, 0x46, 0x15, 0xcb, 0x67,
	0xca, 0xb4, 0xcf, 0x26, 0x2d, 0xa1, 0xc7, 0x68, 0x40, 0x29, 0x4d, 0xfb, 0x1c, 0xd2, 0x40, 0xfc,
	0x0c, 0xfa, 0xe5, 0x3d, 0x67, 0xd2, 0xf4, 0xca, 0x21, 0x3b, 0x10, 0xfc, 0x8b, 0xc0, 0xab, 0xc7,
	0xb7, 0x10, 0x4c, 0x52, 0x93, 0xe2, 0x39, 0x8c, 0x4a, 0x03, 0x4a, 0x59, 0x5b, 0xdb, 0x63, 0xfc,
	0x05, 0xc0, 0x2e, 0x36, 0xf9, 0x2d, 0x93, 0xbf, 0xc3, 0xe8, 0x02, 0x1a, 0x74, 0xc9, 0xb6, 0xf5,
	0x7c, 0xbb, 0x14, 0xfe, 0x06, 0xac, 0x52, 0x18, 0x77, 0xe3, 0xb3, 0x4f, 0x8f, 0x1b, 0xb7, 0x37,
	0x41, 0xac, 0x52, 0xe8, 0xcb, 0x56, 0xb4, 0x5d, 0x88, 0xdd, 0x94, 0xbb, 0x14, 0xfe, 0x1a, 0xc6,
	0xd9, 0x46, 0x4a, 0xc6, 0xd5, 0xe1, 0x80, 0x8f, 0x58, 0xfc, 0x09, 0x0c, 0x24, 0x5b, 0x53, 0xf9,
	0xa1, 0x1e, 0x6c, 0x8d, 0x82, 0xbf, 0x11, 0x8c, 0x62, 0x5e, 0x29, 0xca, 0x33, 0xa6, 0xeb, 0xce,
	0x56, 0x05, 0xe3, 0x2a, 0x6e, 0x46, 0xb2, 0xc7, 0xba, 0xb1, 0xf4, 0x66, 0xf7, 0x69, 0x37, 0x94,
	0x06, 0x76, 0x4e, 0x89, 0xba, 0xdc, 0x3d, 0x6e, 0xf6, 0xbe, 0xf7, 0x60, 0xef, 0xfb, 0xed, 0xde,
	0xbf, 0x00, 0xe7, 0x9e, 0xaa, 0xec, 0xf6, 0x92, 0x6d, 0x2b, 0x7f, 0x30, 0xb1, 0x43, 0x87, 0xb4,
	0x84, 0xde, 0x77, 0x5d, 0x2f, 0x61, 0x9c, 0xdd, 0xa7, 0xc5, 0x9a, 0x55, 0x8a, 0xae, 0x85, 0x29,
	0xc2, 0x26, 0x8f, 0x7c, 0x09, 0xfe, 0x41, 0x70, 0x32, 0x33, 0xce, 0x9a, 0xaa, 0x3a, 0xce, 0xd1,
	0xa1, 0x73, 0x0c, 0x3d, 0x9a, 0xe7, 0xb2, 0x2e, 0xc8, 0xc4, 0xf8, 0x0a, 0x5c, 0xca, 0x79, 0xa9,
	0xcc, 0x10, 0x2a, 0xdf, 0x9e, 0xd8, 0xa1, 0x7b, 0x36, 0x3d, 0x1e, 0xd3, 0x41, 0x86, 0xe9, 0xac,
	0x3d, 0x10, 0x71, 0x25, 0xb7, 0xa4, 0x7b, 0xc5, 0xf3, 0x9f, 0xc1, 0x3b, 0x16, 0x3c, 0xf2, 0x0b,
	0xf1, 0x0c, 0xfa, 0x77, 0x74, 0xb5, 0x61, 0xb5, 0x99, 0x1d, 0x78, 0x69, 0x7d, 0x8f, 0x02, 0x01,
	0x1f, 0x1f, 0xa4, 0x7b, 0x7d, 0x4b, 0xf9, 0x0d, 0xc3, 0xdf, 0x82, 0x5d, 0xf0, 0xaa, 0xfe, 0xe9,
	0xfb, 0xfc, 0x7f, 0x0d, 0x12, 0xad, 0xc4, 0xa1, 0xd9, 0x3b, 0xcb, 0xec, 0x9d, 0xff, 0xe0, 0xc1,
	0x9a, 0x4b, 0x17, 0x42, 0xaf, 0xdd, 0xe9, 0x05, 0xb8, 0x9d, 0x07, 0x8c, 0x5d, 0x18, 0x2e, 0x93,
	0xcb, 0x64, 0xf1, 0x2e, 0xf1, 0x9e, 0xe0, 0x11, 0xf4, 0x7e, 0xbd, 0x5e, 0x24, 0x1e, 0xd2, 0x51,
	0xba, 0x78, 0x33, 0xf7, 0x2c, 0x3c, 0x04, 0x3b, 0x4e, 0x62, 0xcf, 0xc6, 0x27, 0xe0, 0x5c, 0xcd,
	0x67, 0x71, 0x92, 0x46, 0xbf, 0xa5, 0x5e, 0xef, 0xf4, 0x07, 0x70, 0xda, 0x47, 0xe5, 0xc2, 0x30,
	0x4e, 0xde, 0xce, 0xe6, 0xf1, 0xb9, 0xf7, 0x44, 0x9f, 0xb8, 0x8e, 0x52, 0x0f, 0x61, 0x07, 0xfa,
	0xcb, 0x44, 0x87, 0x96, 0x16, 0x5c, 0x2d, 0x5f, 0xcd, 0xe3, 0xeb, 0x5f, 0x3c, 0xfb, 0xf4, 0x25,
	0x8c, 0x1a, 0x4b, 0xfa, 0xd6, 0x65, 0x72, 0x1e, 0x5d, 0xc4, 0x49, 0x54, 0x9f, 0x4d, 0xa2, 0x77,
	0x1e, 0xc2, 0x00, 0x83, 0xe5, 0xd5, 0xf9, 0x2c, 0x8d, 0x3c, 0x4b, 0xc7, 0xe7, 0xd1, 0x3c, 0x4a,
	0x23, 0xcf, 0x7e, 0xe5, 0xfc, 0x3e, 0xac, 0xcb, 0x7a, 0x3f, 0x30, 0xff, 0x23, 0xdf, 0xfd, 0x17,
	0x00, 0x00, 0xff, 0xff, 0xb9, 0xd2, 0xc9, 0x93, 0x56, 0x06, 0x00, 0x00,
}
